diff --git a/src/main/java/net/minecraft/client/gui/GuiIngame.java b/src/main/java/net/minecraft/client/gui/hud/IngameHud.java
similarity index 88%
rename from src/main/java/net/minecraft/client/gui/GuiIngame.java
rename to src/main/java/net/minecraft/client/gui/hud/IngameHud.java
index 35a761ce0..81ef82248 100644
--- a/src/main/java/net/minecraft/client/gui/GuiIngame.java
+++ b/src/main/java/net/minecraft/client/gui/hud/IngameHud.java
@@ -1,4 +1,4 @@
-package net.minecraft.client.gui;
+package net.minecraft.client.gui.hud;
 
 import static net.minecraft.core.util.helper.Utils.*;
 import static org.lwjgl.opengl.GL11.*;
@@ -9,13 +9,18 @@ import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
 
+import com.mojang.logging.LogUtils;
 import net.minecraft.client.entity.player.MultiplayerLocalPlayer;
+import net.minecraft.client.gui.ChatScreen;
+import net.minecraft.client.gui.Gui;
+import net.minecraft.client.gui.HeldItemTooltipElement;
+import net.minecraft.client.gui.PhotoModeScreen;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.gui.hud.HudComponent;
-import net.minecraft.client.gui.hud.HudComponents;
-import net.minecraft.client.render.FontRenderer;
+import net.minecraft.client.gui.hud.component.HudComponent;
+import net.minecraft.client.gui.hud.component.HudComponents;
+import net.minecraft.client.render.Font;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.dynamictexture.DynamicTexture;
 import net.minecraft.client.render.entity.ItemEntityRenderer;
@@ -45,10 +50,11 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.season.Season;
 import net.minecraft.core.world.weather.Weather;
 import net.minecraft.core.world.wind.WindProvider;
+import org.slf4j.Logger;
 
-public class GuiIngame extends Gui
+public class IngameHud extends Gui
 {
-
+    private static final Logger LOGGER = LogUtils.getLogger();
     public static final String[] directions = new String[]{"North", "East", "South", "West"};
 
     public static ItemEntityRenderer itemRenderer = new ItemEntityRenderer();
@@ -60,27 +66,27 @@ public class GuiIngame extends Gui
     private boolean colorString = false;
     public float damageGuiPartialTime;
     float prevVignetteBrightness = 1.0f;
-    protected FontRenderer fontrenderer;
+    protected Font font;
     public int chatScroll = 0;
 
-    public final GuiHeldItemTooltip guiHeldItemTooltip;
+    public final HeldItemTooltipElement heldItemTooltipElement;
 
-    public GuiIngame(Minecraft minecraft)
+    public IngameHud(Minecraft minecraft)
     {
         this.mc = minecraft;
-        this.fontrenderer = mc.fontRenderer;
-        this.guiHeldItemTooltip = new GuiHeldItemTooltip(mc);
+        this.font = mc.font;
+        this.heldItemTooltipElement = new HeldItemTooltipElement(mc);
     }
 
     public void renderGameOverlay(float partialTicks, boolean flag, int mouseX, int mouseY)
     {
-        if (mc.currentScreen instanceof GuiPhotoMode) return;
+        if (mc.currentScreen instanceof PhotoModeScreen) return;
 
         I18n stringtranslate = I18n.getInstance();
         int width = mc.resolution.scaledWidth;
         int height = mc.resolution.scaledHeight;
         int sp = (int) (mc.gameSettings.screenPadding.value * height / 8);
-        FontRenderer fontrenderer = mc.fontRenderer;
+        Font font = mc.font;
         mc.worldRenderer.setupScaledResolution();
 
         GL11.glEnable(3042 /* GL_BLEND */);
@@ -410,12 +416,12 @@ public class GuiIngame extends Gui
                     } else {
                         color = 0xFFFFFF;
                     }
-                    drawString(fontrenderer, "Better than Adventure! ", tsp, tsp + lineHeight * line, color);
-                    drawString(fontrenderer, Global.VERSION, tsp + fontrenderer.getStringWidth("Better than Adventure! "), tsp + lineHeight * line++, 0xffffff);
+                    drawString(font, "Better than Adventure! ", tsp, tsp + lineHeight * line, color);
+                    drawString(font, Global.VERSION, tsp + font.getStringWidth("Better than Adventure! "), tsp + lineHeight * line++, 0xffffff);
                 }
                 if (mc.gameSettings.fpsInOverlay.value)
                 {
-                    drawString(fontrenderer, mc.debugFPS, tsp, tsp + lineHeight * line++, 0xffffff);
+                    drawString(font, mc.debugFPS, tsp, tsp + lineHeight * line++, 0xffffff);
                 }
                 if (compass)
                 {
@@ -423,24 +429,24 @@ public class GuiIngame extends Gui
                     {
                         if (mc.gameSettings.overlayMode.value == 0)
                         {
-                            drawString(fontrenderer, "x: " + floor10(mc.thePlayer.x) + " y: " + floor10(mc.thePlayer.y) + " z: " + floor10(mc.thePlayer.z), tsp, tsp + lineHeight * line++, 0xffffff);
+                            drawString(font, "x: " + floor10(mc.thePlayer.x) + " y: " + floor10(mc.thePlayer.y) + " z: " + floor10(mc.thePlayer.z), tsp, tsp + lineHeight * line++, 0xffffff);
                         }
                         if (mc.gameSettings.overlayMode.value == 1)
                         {
-                            drawString(fontrenderer, "x: " + floor10(mc.thePlayer.x), tsp, tsp + lineHeight * line++, 0xffffff);
-                            drawString(fontrenderer, "y: " + floor10(mc.thePlayer.y), tsp, tsp + lineHeight * line++, 0xffffff);
-                            drawString(fontrenderer, "z: " + floor10(mc.thePlayer.z), tsp, tsp + lineHeight * line++, 0xffffff);
+                            drawString(font, "x: " + floor10(mc.thePlayer.x), tsp, tsp + lineHeight * line++, 0xffffff);
+                            drawString(font, "y: " + floor10(mc.thePlayer.y), tsp, tsp + lineHeight * line++, 0xffffff);
+                            drawString(font, "z: " + floor10(mc.thePlayer.z), tsp, tsp + lineHeight * line++, 0xffffff);
                         }
                         if (mc.gameSettings.overlayMode.value == 2)
                         {
-                            drawString(fontrenderer, "x: " + floor10(mc.thePlayer.x), tsp, tsp + lineHeight * line++, 0xff8080);
-                            drawString(fontrenderer, "y: " + floor10(mc.thePlayer.y), tsp, tsp + lineHeight * line++, 0x80ff80);
-                            drawString(fontrenderer, "z: " + floor10(mc.thePlayer.z), tsp, tsp + lineHeight * line++, 0x8080ff);
+                            drawString(font, "x: " + floor10(mc.thePlayer.x), tsp, tsp + lineHeight * line++, 0xff8080);
+                            drawString(font, "y: " + floor10(mc.thePlayer.y), tsp, tsp + lineHeight * line++, 0x80ff80);
+                            drawString(font, "z: " + floor10(mc.thePlayer.z), tsp, tsp + lineHeight * line++, 0x8080ff);
                         }
                     }
                     if (mc.gameSettings.overlayShowDirection.value)
                     {
-                        drawString(fontrenderer, getFacingDirection(mc.thePlayer), tsp, tsp + lineHeight * line++, 0xffffff);
+                        drawString(font, getFacingDirection(mc.thePlayer), tsp, tsp + lineHeight * line++, 0xffffff);
                     }
                 }
                 if (clock)
@@ -449,12 +455,12 @@ public class GuiIngame extends Gui
                     {
                         if (mc.gameSettings.overlayMode.value == 0)
                         {
-                            this.drawString(fontrenderer, getTimeString() + " Day " + mc.theWorld.getWorldTime() / Global.DAY_LENGTH_TICKS, tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xffff80 : 0xffffff);
+                            this.drawString(font, getTimeString() + " Day " + mc.theWorld.getWorldTime() / Global.DAY_LENGTH_TICKS, tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xffff80 : 0xffffff);
                         }
                         if (mc.gameSettings.overlayMode.value > 0)
                         {
-                            this.drawString(fontrenderer, getTimeString(), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xffff80 : 0xffffff);
-                            this.drawString(fontrenderer, "Day " + mc.theWorld.getWorldTime() / Global.DAY_LENGTH_TICKS, tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xffff80 : 0xffffff);
+                            this.drawString(font, getTimeString(), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xffff80 : 0xffffff);
+                            this.drawString(font, "Day " + mc.theWorld.getWorldTime() / Global.DAY_LENGTH_TICKS, tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xffff80 : 0xffffff);
                         }
                     }
                 }
@@ -465,7 +471,7 @@ public class GuiIngame extends Gui
                         Season season = mc.theWorld.getSeasonManager().getCurrentSeason();
                         if (season != null)
                         {
-                            this.drawString(fontrenderer, season.getTranslatedName(), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0x80ffff : 0xffffff);
+                            this.drawString(font, season.getTranslatedName(), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0x80ffff : 0xffffff);
                         }
                     }
                     if (mc.gameSettings.overlayShowWeather.value)
@@ -473,7 +479,7 @@ public class GuiIngame extends Gui
                         Weather weather = mc.theWorld.getCurrentWeather();
                         if (weather != null && weather != mc.theWorld.worldType.getDefaultWeather())
                         {
-                            this.drawString(fontrenderer, weather.getTranslatedName(), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xff80ff : 0xffffff);
+                            this.drawString(font, weather.getTranslatedName(), tsp, tsp + lineHeight * line++, mc.gameSettings.overlayMode.value == 2 ? 0xff80ff : 0xffffff);
                         }
                     }
 					if(mc.gameSettings.overlayShowBiome.value)
@@ -482,7 +488,7 @@ public class GuiIngame extends Gui
 						int blockY = MathHelper.floor(mc.thePlayer.y);
 						int blockZ = MathHelper.floor(mc.thePlayer.z);
 						String key = mc.theWorld.getBlockBiome(blockX, blockY, blockZ).translationKey;
-						drawString(fontrenderer, stringtranslate.translateKey(key), tsp, tsp + lineHeight * line++, 0xffffff);
+						drawString(font, stringtranslate.translateKey(key), tsp, tsp + lineHeight * line++, 0xffffff);
 					}
                 }
             }
@@ -498,7 +504,7 @@ public class GuiIngame extends Gui
                 {
                     int x = 2 + sp;
                     int y = height - sp - 64 + i * 16;
-                    ItemModelDispatcher.getInstance().getDispatch(stack).renderItemIntoGui(Tessellator.instance, fontrenderer, mc.renderEngine, stack, x, y, 1.0f);
+                    ItemModelDispatcher.getInstance().getDispatch(stack).renderItemIntoGui(Tessellator.instance, font, mc.textureManager, stack, x, y, 1.0f);
 
                     if (stack.isItemStackDamageable())
                     {
@@ -509,7 +515,7 @@ public class GuiIngame extends Gui
 
                         glDisable(GL_BLEND);
                         glDisable(GL_LIGHTING);
-                        fontrenderer.drawStringWithShadow(String.valueOf((stack.getMaxDamage() - stack.getMetadata()) + 1), x + 20, y + 4, i1);
+                        font.drawStringWithShadow(String.valueOf((stack.getMaxDamage() - stack.getMetadata()) + 1), x + 20, y + 4, i1);
                     }
                 }
             }
@@ -532,11 +538,10 @@ public class GuiIngame extends Gui
                 {
                     renderItem = true;
                     float durability = (heldItemStack.getMaxDamage() - heldItemStack.getMetadata()) / (float) heldItemStack.getMaxDamage();
-
-                    int l = (int) (durability * 255);
-                    final int i1 = 255 - l << 16 | l << 8;
+                    
+                    final int color = Color.HSBtoRGB(durability/3F, 1f, 1f);
                     int remainingDurability = (heldItemStack.getMaxDamage() - heldItemStack.getMetadata()) + 1;
-                    fontrenderer.drawStringWithShadow("" + remainingDurability, x + 18, y + 4, i1);
+                    font.drawStringWithShadow("" + remainingDurability, x + 18, y + 4, color);
                 }
                 else
                 {
@@ -555,7 +560,7 @@ public class GuiIngame extends Gui
 
                     if (renderItem)
                     {
-                        fontrenderer.drawStringWithShadow("" + itemCount, x + 18, y + 4, 0xffffff);
+                        font.drawStringWithShadow("" + itemCount, x + 18, y + 4, 0xffffff);
                     }
                 }
 
@@ -565,7 +570,7 @@ public class GuiIngame extends Gui
                     GL11.glDisable(3042 /* GL_BLEND */);
                     GL11.glEnable(32826 /* GL_RESCALE_NORMAL_EXT */);
                     Lighting.enableInventoryLight();
-                    ItemModelDispatcher.getInstance().getDispatch(heldItemStack).renderItemIntoGui(Tessellator.instance, fontrenderer, mc.renderEngine, heldItemStack, x, y, 1.0f);
+                    ItemModelDispatcher.getInstance().getDispatch(heldItemStack).renderItemIntoGui(Tessellator.instance, font, mc.textureManager, heldItemStack, x, y, 1.0f);
                     Lighting.disable();
                 }
             }
@@ -637,7 +642,7 @@ public class GuiIngame extends Gui
 
     private void drawDebugScreenLine(String string, boolean right, int line, int offset)
     {
-        int width = fontrenderer.getStringWidth(string);
+        int width = font.getStringWidth(string);
         int height = debugLineHeight;
         int x = right ? mc.resolution.scaledWidth - width - 2 : 2;
         int y = 3 + line * debugLineHeight + offset;
@@ -653,7 +658,7 @@ public class GuiIngame extends Gui
         glEnable(GL_TEXTURE_2D);
 
 //		fontrenderer.drawStringWithShadow(string, x, y, 0xFFFFFF);
-        fontrenderer.drawString(string, x, y, 0xFFFFFF);
+        font.drawString(string, x, y, 0xFFFFFF);
     }
 
     private void drawDebugScreenLine(String string)
@@ -696,9 +701,9 @@ public class GuiIngame extends Gui
 
         for (Map.Entry<String, String> a1 : players.entrySet())
         {
-            longestNameWidth = java.lang.Math.max(fontrenderer.getStringWidth(a1.getKey()), longestNameWidth);
+            longestNameWidth = java.lang.Math.max(font.getStringWidth(a1.getKey()), longestNameWidth);
 
-            longestScoreWidth = java.lang.Math.max(fontrenderer.getStringWidth(a1.getValue()), longestScoreWidth);
+            longestScoreWidth = java.lang.Math.max(font.getStringWidth(a1.getValue()), longestScoreWidth);
             playerListScoreStrings.add(a1.getValue());
         }
 
@@ -742,11 +747,11 @@ public class GuiIngame extends Gui
             int posX = listX + x * columnWidth + x * innerPadding + outerPadding;
             int posY = listY + y * lineHeight + y * innerPadding + outerPadding;
 
-            int scoreStringWidth = fontrenderer.getStringWidth(a2.getValue());
+            int scoreStringWidth = font.getStringWidth(a2.getValue());
             drawRect(posX - 2, posY - 2, posX + columnWidth + 2, posY + 10, 0xffa5a5a5);
             drawRect(posX - 1, posY - 1, posX + columnWidth + 1, posY + 9, 0xA8080808);
-            fontrenderer.drawStringWithShadow(a2.getKey(), posX, posY, 0xFFFFFF);
-            fontrenderer.drawStringWithShadow(TextFormatting.YELLOW + a2.getValue(), posX + columnWidth - scoreStringWidth, posY, 0xFFFFFF);
+            font.drawStringWithShadow(a2.getKey(), posX, posY, 0xFFFFFF);
+            font.drawStringWithShadow(TextFormatting.YELLOW + a2.getValue(), posX + columnWidth - scoreStringWidth, posY, 0xFFFFFF);
             i++;
         }
     }
@@ -772,7 +777,7 @@ public class GuiIngame extends Gui
                 {
                     k4 = Color.HSBtoRGB(f2 / 50F, 0.7F, 0.6F) & 0xffffff;
                 }
-                fontrenderer.drawString(recordPlaying, -fontrenderer.getStringWidth(recordPlaying) / 2, -4, k4 + (j3 << 24));
+                font.drawString(recordPlaying, -font.getStringWidth(recordPlaying) / 2, -4, k4 + (j3 << 24));
                 GL11.glDisable(3042 /* GL_BLEND */);
                 GL11.glPopMatrix();
             }
@@ -783,7 +788,7 @@ public class GuiIngame extends Gui
     {
         int messagesToShow = 10;
         boolean ignoreFadeout = false;
-        if (mc.currentScreen instanceof GuiChat)
+        if (mc.currentScreen instanceof ChatScreen)
         {
             int acceptableSize = height - 48 - 48;
             messagesToShow = acceptableSize / 9;
@@ -828,7 +833,7 @@ public class GuiIngame extends Gui
                 String s1 = chatMessageList.get(i).message;
                 drawRect(xPad, y - 1 - sp, xPad + 320, y + 8 - sp, alpha / 2 << 24);
                 GL11.glEnable(GL_BLEND);
-                mc.fontRenderer.drawStringWithShadow(s1, xPad, y - sp, 0xFFFFFF + (alpha << 24));
+                mc.font.drawStringWithShadow(s1, xPad, y - sp, 0xFFFFFF + (alpha << 24));
             }
         }
 
@@ -870,7 +875,7 @@ public class GuiIngame extends Gui
         GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         GL11.glDisable(3008 /* GL_ALPHA_TEST */);
-        mc.renderEngine.loadTexture("/assets/minecraft/textures/misc/pumpkinblur.png").bind();
+        mc.textureManager.loadTexture("/assets/minecraft/textures/misc/pumpkinblur.png").bind();
         Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
         tessellator.addVertexWithUV(0.0D, ySize, -90D, 0.0D, 1.0D);
@@ -892,7 +897,7 @@ public class GuiIngame extends Gui
         GL11.glDepthMask(false);
         GL11.glBlendFunc(0, 769);
         GL11.glColor4f(prevVignetteBrightness, prevVignetteBrightness, prevVignetteBrightness, 1.0F);
-        mc.renderEngine.loadTexture("/assets/minecraft/textures/misc/vignette.png").bind();
+        mc.textureManager.loadTexture("/assets/minecraft/textures/misc/vignette.png").bind();
         Tessellator tessellator = Tessellator.instance;
         tessellator.startDrawingQuads();
         tessellator.addVertexWithUV(0.0D, ySize, -90D, 0.0D, 1.0D);
@@ -958,14 +963,14 @@ public class GuiIngame extends Gui
 
     public void addChatMessage(String s)
     {
-        System.out.println("[CHAT] " + s);
+        LOGGER.info("[CHAT] {}", s);
         int i;
         TextFormatting activeFormatting = null;
-        while (mc.fontRenderer.getStringWidth(s) > 320)
+        while (mc.font.getStringWidth(s) > 320)
         {
-            for (i = 1; i < s.length() && mc.fontRenderer.getStringWidth(s.substring(0, i + 1)) <= 320; i++) {
+            for (i = 1; i < s.length() && mc.font.getStringWidth(s.substring(0, i + 1)) <= 320; i++) {
                 char c = s.charAt(i - 1);
-                if (c == '\u00a7') {
+                if (c == '§') {
                     char code = s.charAt(i);
                     for (TextFormatting formatting : TextFormatting.FORMATTINGS) {
                         if (formatting.code == code) {
@@ -977,7 +982,7 @@ public class GuiIngame extends Gui
             }
             addChatMessage(s.substring(0, i));
             if (activeFormatting != null) {
-                s = "" + '\u00a7' + activeFormatting.code + s.substring(i);
+                s = "" + '§' + activeFormatting.code + s.substring(i);
             } else {
                 s = s.substring(i);
             }
diff --git a/src/main/java/net/minecraft/client/gui/hud/ArmorBarComponent.java b/src/main/java/net/minecraft/client/gui/hud/component/ArmorBarComponent.java
similarity index 87%
rename from src/main/java/net/minecraft/client/gui/hud/ArmorBarComponent.java
rename to src/main/java/net/minecraft/client/gui/hud/component/ArmorBarComponent.java
index 80905322f..ec4a3fe79 100644
--- a/src/main/java/net/minecraft/client/gui/hud/ArmorBarComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/component/ArmorBarComponent.java
@@ -1,8 +1,9 @@
-package net.minecraft.client.gui.hud;
+package net.minecraft.client.gui.hud.component;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
-import net.minecraft.client.gui.GuiIngame;
+import net.minecraft.client.gui.hud.IngameHud;
+import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import org.lwjgl.opengl.GL11;
@@ -25,7 +26,7 @@ public class ArmorBarComponent
     }
 
     @Override
-    public void render(Minecraft mc, GuiIngame gui, int xSizeScreen, int ySizeScreen, float partialTick) {
+    public void render(Minecraft mc, IngameHud hud, int xSizeScreen, int ySizeScreen, float partialTick) {
         int x = this.getLayout().getComponentX(mc, this, xSizeScreen);
         int y = this.getLayout().getComponentY(mc, this, ySizeScreen);
 
@@ -41,17 +42,17 @@ public class ArmorBarComponent
                 if (i * 2 + 1 < armorValue)
                 {
                     // Full armor icon
-                    gui.drawGuiIcon(xArmor, y, 9, 9, armor_full);
+                    hud.drawGuiIcon(xArmor, y, 9, 9, armor_full);
                 }
                 if (i * 2 + 1 == armorValue)
                 {
                     // Half armor icon
-                    gui.drawGuiIcon(xArmor, y, 9, 9, armor_half);
+                    hud.drawGuiIcon(xArmor, y, 9, 9, armor_half);
                 }
                 if (i * 2 + 1 > armorValue)
                 {
                     // Empty armor icon
-                    gui.drawGuiIcon(xArmor, y, 9, 9, armor_empty);
+                    hud.drawGuiIcon(xArmor, y, 9, 9, armor_empty);
                 }
             }
         }
diff --git a/src/main/java/net/minecraft/client/gui/hud/ComponentAnchor.java b/src/main/java/net/minecraft/client/gui/hud/component/ComponentAnchor.java
similarity index 92%
rename from src/main/java/net/minecraft/client/gui/hud/ComponentAnchor.java
rename to src/main/java/net/minecraft/client/gui/hud/component/ComponentAnchor.java
index e7c5164df..58d47f18c 100644
--- a/src/main/java/net/minecraft/client/gui/hud/ComponentAnchor.java
+++ b/src/main/java/net/minecraft/client/gui/hud/component/ComponentAnchor.java
@@ -1,4 +1,4 @@
-package net.minecraft.client.gui.hud;
+package net.minecraft.client.gui.hud.component;
 
 public enum ComponentAnchor {
     TOP_LEFT(0.0F, 0.0F),
diff --git a/src/main/java/net/minecraft/client/gui/hud/CrosshairComponent.java b/src/main/java/net/minecraft/client/gui/hud/component/CrosshairComponent.java
similarity index 83%
rename from src/main/java/net/minecraft/client/gui/hud/CrosshairComponent.java
rename to src/main/java/net/minecraft/client/gui/hud/component/CrosshairComponent.java
index 866703502..f3fd3d68a 100644
--- a/src/main/java/net/minecraft/client/gui/hud/CrosshairComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/component/CrosshairComponent.java
@@ -1,8 +1,9 @@
-package net.minecraft.client.gui.hud;
+package net.minecraft.client.gui.hud.component;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
-import net.minecraft.client.gui.GuiIngame;
+import net.minecraft.client.gui.hud.IngameHud;
+import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import org.lwjgl.opengl.GL11;
 
@@ -18,7 +19,7 @@ public class CrosshairComponent
     }
 
     @Override
-    public void render(Minecraft mc, GuiIngame gui, int xSizeScreen, int ySizeScreen, float partialTick) {
+    public void render(Minecraft mc, IngameHud hud, int xSizeScreen, int ySizeScreen, float partialTick) {
         int x = this.getLayout().getComponentX(mc, this, xSizeScreen);
         int y = this.getLayout().getComponentY(mc, this, ySizeScreen);
 
@@ -28,7 +29,7 @@ public class CrosshairComponent
         // Render crosshair
         GL11.glEnable(GL11.GL_BLEND);
         GL11.glBlendFunc(GL11.GL_ONE_MINUS_DST_COLOR, GL11.GL_ONE_MINUS_SRC_COLOR);
-        gui.drawGuiIcon(x, y, 15, 15, TextureRegistry.getTexture("minecraft:gui/hud/crosshair"));
+        hud.drawGuiIcon(x, y, 15, 15, TextureRegistry.getTexture("minecraft:gui/hud/crosshair"));
         GL11.glDisable(GL11.GL_BLEND);
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/hud/FireBarComponent.java b/src/main/java/net/minecraft/client/gui/hud/component/FireBarComponent.java
similarity index 85%
rename from src/main/java/net/minecraft/client/gui/hud/FireBarComponent.java
rename to src/main/java/net/minecraft/client/gui/hud/component/FireBarComponent.java
index f9a177ba9..2969466bf 100644
--- a/src/main/java/net/minecraft/client/gui/hud/FireBarComponent.java
+++ b/src/main/java/net/minecraft/client/gui/hud/component/FireBarComponent.java
@@ -1,8 +1,9 @@
-package net.minecraft.client.gui.hud;
+package net.minecraft.client.gui.hud.component;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.Gui;
-import net.minecraft.client.gui.GuiIngame;
+import net.minecraft.client.gui.hud.IngameHud;
+import net.minecraft.client.gui.hud.component.layout.Layout;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import org.lwjgl.opengl.GL11;
 
@@ -18,7 +19,7 @@ public class FireBarComponent
     }
 
     @Override
-    public void render(Minecraft mc, GuiIngame gui, int xSizeScreen, int ySizeScreen, float partialTick) {
+    public void render(Minecraft mc, IngameHud hud, int xSizeScreen, int ySizeScreen, float partialTick) {
         int x = this.getLayout().getComponentX(mc, this, xSizeScreen);
         int y = this.getLayout().getComponentY(mc, this, ySizeScreen);
 
@@ -30,7 +31,7 @@ public class FireBarComponent
         int fireBar = (int) Math.min(fire * 20,20);
 
         for (int i = 0; i < fireBar / 2; i++) {
-            gui.drawGuiIcon(x + i * 8, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/fire"));
+            hud.drawGuiIcon(x + i * 8, y, 9, 9, TextureRegistry.getTexture("minecraft:gui/hud/fire"));
         }
     }
 
